// ----------------------------------------------------------------------------
// BUTTONS
// ----------------------------------------------------------------------------

// Buttons are used throughout the application for actions on forms and links
// that act as calls to action. They should always be styled with a primary,
// and other buttons should have lower visual weight. Sometimes, we'll have
// all the buttons in an area seem to be low-weight in order to not distract
// from other parts of the page or the main action flow.
//
// Styleguide 2.1

// ----------------------------------------------------------------------------
//  Button Structure
// ------------------------------------------------------------------

button,
.button,
input[type="button"],
input[type="reset"],
input[type="submit"] {
  border: 3px solid white;
  border-radius: $base-border-radius * 2;
  background-color: $button-default-background;
  box-shadow: none;
  display: inline-block;
  color: $white;
  padding: ($base-line-height  / 4) 20px ($base-line-height  / 4) 20px;
  outline: none;
  font-family: $libertarian-stack2;
  @include font-size(24px);
  font-weight: bold;
  letter-spacing: .07rem;
  text-decoration: none;
  text-transform: uppercase;
  transition: background-color .25s linear, color .25s linear;

  // Focus state for keyboard and accessibility
  &:focus,
  &:hover {
    background-color: $button-default-background-hover;
    color: $white;
    box-shadow: none;
  }

  // Active state
  &:active {
    background-color: $button-default-background-active;
    opacity: .8;
  }

  &:visited {
    color: $white !important;
  }

  // Disabled state
  &.disabled,
  &[disabled] {
    background-color: $gray;
    background-image: none;
    color: $gray-darker;
    box-shadow: none;
    cursor: not-allowed;
  }

} // button, .btn


// Button Classes
//
// .button-primary          - primary call to action button
// .button-disabled         - a button that is not clickable
// .button-danger           - a button for bad things
// .button-success          - a button for good things
// .button-warning          - a button for possibly bad things
// .button-small            - small button
//
// Styleguide 2.1.1


// Button Sizes (Use By @Extend)
// ------------------------------------------------------------------

%button-small,
.button-small {
  &.button,
  &.input[type="button"],
  &.input[type="reset"],
  &.input[type="submit"] {
  background-position: calc(100% - 8px) center;
  background-size: auto 10px;
  border-radius: 6px !important;
  padding: 2px 5px;
  @include font-size(13px);
  font-weight: 600;
  }
}

%button-medium,
.button-medium {
  &.button,
  &.input[type="button"],
  &.input[type="reset"],
  &.input[type="submit"] {
  background-position: calc(100% - 8px) center;
  background-size: auto 10px;
  padding: 4px 7px 2px 9px;
  font-size: $base-font-size;
  font-weight: 500;
  }
}

//  Button States (Color)
// ------------------------------------------------------------------

$button-color-list:
  primary $button-primary-background $button-primary-background-hover $button-primary-background-active,
  disabled $button-disabled-background $button-disabled-background-hover $button-disabled-background-active,
  danger $button-danger-background $button-danger-background-hover $button-danger-background-active,
  success $button-success-background $button-success-background-hover $button-success-background-active,
  warning $button-warning-background $button-warning-background-hover $button-warning-background-active;

@each $button-type, $background-color, $hover-color, $active-color in $button-color-list {

  button.button-#{$button-type},
  .button.button-#{$button-type},
  input[type="button"].button-#{$button-type},
  input[type="reset"].button-#{$button-type},
  input[type="submit"].button-#{$button-type} {
    background-color: $background-color;

   &:focus,
   &:hover {
     background-color: $hover-color;
   }

   &:active {
     background-color: $active-color;
   }

  } // .button-#{$button-type} {

} // @each $button-type in $button-type-list {

  .button-disabled {
    color: $button-disabled-text;
  }

  .button-primary {
    font-size: $base-font-size * 1.25;
  }

//  Button Types (Icon)
// ------------------------------------------------------------------

//$button-type-list:
//  add white plus,
//  remove white x;
//
//@each $type, $color, $icon in $button-type-list {
//
//  .button-#{$type} {
//    background-image: url(asset-path("#{$image-path}/icons-colored/#{$color}/#{$icon}.svg"));
//   }
//
//} // @each $button-type in $button-type-list {
